/***************************************************************************
 *   Copyright (C) 2007 by ASL-ETH                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#include <makekeys.h>

bool makekeys(string name, string dirFolder, string dirCap, char opsys)
{
	string keyname="key/"+name+".key";
	string imaname=dirFolder+"/"+name+".pgm";
	string command="";
	
	if( checkFile(keyname) )
	{
		cout<<"Keypoints already generated."<<endl;
		return false;
	}
	
	if( checkFile(imaname) )
	{
		//if pgm exists create keypoints and exit
		cout<<"Extracting keypoints"<<endl;
		if (opsys=='l')
			command="bin/sift <"+imaname+" >"+keyname;
		else
			command="bin\\siftWin32.exe <"+imaname+" >"+keyname;
		system(command.c_str());
	}
	else
	{
		cout<<"Converting file "<<imaname<<endl;
		string jpgimaname=dirFolder+"/"+name+".jpg";
		string imaname=dirCap+"/"+name+".pgm";

		if( !checkFile(jpgimaname) )
		{
			cout<<"Image not found."<<endl;
			return false;
		}
		if (opsys=='l')
			command="convert "+jpgimaname+" "+imaname;
		else
			command="C:\\Programme\\IrfanView\\i_view32 "+jpgimaname+" /convert="+imaname;
		system(command.c_str());
		
		cout<<"Extracting keypoints"<<endl;
		if (opsys=='l')
			command="bin/sift <"+imaname+" >"+keyname;
		else
			command="bin\\siftWin32.exe <"+imaname+" >"+keyname;
		system(command.c_str());
	}
	
	return true;
}


bool checkFile(const string &path_name)
{
	fstream fin;

	fin.open(path_name.c_str(),ios::in);
	if( fin.is_open() )
	{
		fin.close();
		return true;
	}
	else
	{
		fin.close();
		return false;
	}
}


